Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/phyredem.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/phyredem.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/phyredem.F90	(revision 3605)
@@ -29,5 +29,5 @@
                                 treedrg, ds_ns, dt_ns
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
-  USE iostart, ONLY: open_restartphy, close_restartphy, put_field, put_var
+  USE iostart, ONLY: open_restartphy, close_restartphy, enddef_restartphy, put_field, put_var
   USE traclmdz_mod, ONLY : traclmdz_to_restart
   USE infotrac_phy, ONLY: type_trac, niadv, tname, nbtr, nqo
@@ -66,5 +66,5 @@
   CHARACTER (len=2) :: str2
   CHARACTER (len=256) :: nam, lnam
-  INTEGER           :: it, iiq
+  INTEGER           :: it, iiq, pass
 
   !======================================================================
@@ -81,4 +81,5 @@
   CALL open_restartphy(fichnom)
 
+  
   DO ierr = 1, length
      tab_cntrl(ierr) = 0.0
@@ -105,243 +106,248 @@
   tab_cntrl(16) = co2_ppm0
 
-  CALL put_var("controle", "Parametres de controle", tab_cntrl)
-
-  CALL put_field("longitude", &
-       "Longitudes de la grille physique", longitude_deg)
-
-  CALL put_field("latitude", "Latitudes de la grille physique", latitude_deg)
-
-  ! PB ajout du masque terre/mer
-
-  CALL put_field("masque", "masque terre mer", zmasq)
-
-  ! BP ajout des fraction de chaque sous-surface
-
-  ! Get last fractions from slab ocean
-  IF (type_ocean == 'slab' .AND. version_ocean == "sicINT") THEN
-      WHERE (1.-zmasq(:).GT.EPSFRA)
-          pctsrf(:,is_oce)=(1.-fsic(:))*(1.-zmasq(:))
-          pctsrf(:,is_sic)=fsic(:)*(1.-zmasq(:))
-      END WHERE
-  END IF
-
-  ! 1. fraction de terre 
-
-  CALL put_field("FTER", "fraction de continent", pctsrf(:, is_ter))
-
-  ! 2. Fraction de glace de terre
-
-  CALL put_field("FLIC", "fraction glace de terre", pctsrf(:, is_lic))
-
-  ! 3. fraction ocean
-
-  CALL put_field("FOCE", "fraction ocean", pctsrf(:, is_oce))
-
-  ! 4. Fraction glace de mer
-
-  CALL put_field("FSIC", "fraction glace mer", pctsrf(:, is_sic))
-
-  IF(nbsrf>99) THEN
-    PRINT*, "Trop de sous-mailles";  CALL abort_physic("phyredem", "", 1)
-  END IF
-  IF(nsoilmx>99) THEN
-    PRINT*, "Trop de sous-surfaces"; CALL abort_physic("phyredem", "", 1)
-  END IF
-  IF(nsw>99) THEN
-    PRINT*, "Trop de bandes"; CALL abort_physic("phyredem", "", 1)
-  END IF
-
-  CALL put_field_srf1("TS","Temperature",ftsol(:,:))
+  DO pass=1,2   ! pass=1 netcdf definition ; pass=2 netcdf write
+  
+    CALL put_var(pass, "controle", "Parametres de controle", tab_cntrl)
+
+    CALL put_field(pass,"longitude", &
+         "Longitudes de la grille physique", longitude_deg)
+
+    CALL put_field(pass,"latitude", "Latitudes de la grille physique", latitude_deg)
+
+    ! PB ajout du masque terre/mer
+
+    CALL put_field(pass,"masque", "masque terre mer", zmasq)
+
+    ! BP ajout des fraction de chaque sous-surface
+
+    ! Get last fractions from slab ocean
+    IF (type_ocean == 'slab' .AND. version_ocean == "sicINT") THEN
+        WHERE (1.-zmasq(:).GT.EPSFRA)
+            pctsrf(:,is_oce)=(1.-fsic(:))*(1.-zmasq(:))
+            pctsrf(:,is_sic)=fsic(:)*(1.-zmasq(:))
+        END WHERE
+    END IF
+
+    ! 1. fraction de terre 
+
+    CALL put_field(pass,"FTER", "fraction de continent", pctsrf(:, is_ter))
+
+    ! 2. Fraction de glace de terre
+
+    CALL put_field(pass,"FLIC", "fraction glace de terre", pctsrf(:, is_lic))
+
+    ! 3. fraction ocean
+
+    CALL put_field(pass,"FOCE", "fraction ocean", pctsrf(:, is_oce))
+
+    ! 4. Fraction glace de mer
+
+    CALL put_field(pass,"FSIC", "fraction glace mer", pctsrf(:, is_sic))
+
+    IF(nbsrf>99) THEN
+      PRINT*, "Trop de sous-mailles";  CALL abort_physic("phyredem", "", 1)
+    END IF
+    IF(nsoilmx>99) THEN
+      PRINT*, "Trop de sous-surfaces"; CALL abort_physic("phyredem", "", 1)
+    END IF
+    IF(nsw>99) THEN
+      PRINT*, "Trop de bandes"; CALL abort_physic("phyredem", "", 1)
+    END IF
+
+    CALL put_field_srf1(pass,"TS","Temperature",ftsol(:,:))
 
 ! ================== Albedo =======================================
-  print*,'PHYREDEM NOUVEAU'
-  CALL put_field_srf2("A_dir_SW","Albedo direct",falb_dir(:,:,:))
-  CALL put_field_srf2("A_dif_SW","Albedo diffus",falb_dif(:,:,:))
-
-  CALL put_field_srf1("U10M", "u a 10m", u10m)
-
-  CALL put_field_srf1("V10M", "v a 10m", v10m)
+    print*,'PHYREDEM NOUVEAU'
+    CALL put_field_srf2(pass,"A_dir_SW","Albedo direct",falb_dir(:,:,:))
+    CALL put_field_srf2(pass,"A_dif_SW","Albedo diffus",falb_dif(:,:,:))
+
+    CALL put_field_srf1(pass,"U10M", "u a 10m", u10m)
+
+    CALL put_field_srf1(pass,"V10M", "v a 10m", v10m)
 
 
 ! ================== Tsoil =========================================
-  CALL put_field_srf2("Tsoil","Temperature",tsoil(:,:,:))
+    CALL put_field_srf2(pass,"Tsoil","Temperature",tsoil(:,:,:))
 !FC
 !  CALL put_field_srf2("treedrg","freinage arbres",treedrg(:,:,:))
-  CALL put_field("treedrg_ter","freinage arbres",treedrg(:,:,is_ter))
-
-
-  CALL put_field_srf1("QS"  , "Humidite",qsurf(:,:))
-
-  CALL put_field     ("QSOL", "Eau dans le sol (mm)", qsol)
-
-  CALL put_field_srf1("EVAP", "Evaporation", fevap(:,:))
-
-  CALL put_field_srf1("SNOW", "Neige", snow(:,:))
-
-  CALL put_field("RADS", "Rayonnement net a la surface", radsol)
-
-  CALL put_field("solsw", "Rayonnement solaire a la surface", solsw)
-
-  CALL put_field("sollw", "Rayonnement IF a la surface", sollw)
-
-  CALL put_field("sollwdown", "Rayonnement down IF a la surface", sollwdown)
-
-  CALL put_field("fder", "Derive de flux", fder)
-
-  CALL put_field("rain_f", "precipitation liquide", rain_fall)
-
-  CALL put_field("snow_f", "precipitation solide", snow_fall)
-
-  CALL put_field_srf1("Z0m", "rugosite", z0m(:,:))
-
-  CALL put_field_srf1("Z0h", "rugosite", z0h(:,:))
-
-  CALL put_field_srf1("AGESNO", "Age de la neige", agesno(:,:))
-
-  CALL put_field("ZMEA", "ZMEA", zmea)
-
-  CALL put_field("ZSTD", "ZSTD", zstd)
-
-  CALL put_field("ZSIG", "ZSIG", zsig)
-
-  CALL put_field("ZGAM", "ZGAM", zgam)
-
-  CALL put_field("ZTHE", "ZTHE", zthe)
-
-  CALL put_field("ZPIC", "ZPIC", zpic)
-
-  CALL put_field("ZVAL", "ZVAL", zval)
-
-  CALL put_field("RUGSREL", "RUGSREL", rugoro)
-
-  CALL put_field("TANCIEN", "TANCIEN", t_ancien)
-
-  CALL put_field("QANCIEN", "QANCIEN", q_ancien)
-
-  CALL put_field("QLANCIEN", "QLANCIEN", ql_ancien)
-
-  CALL put_field("QSANCIEN", "QSANCIEN", qs_ancien)
-
-  CALL put_field("PRWANCIEN", "PRWANCIEN", prw_ancien)
-
-  CALL put_field("PRLWANCIEN", "PRLWANCIEN", prlw_ancien)
-
-  CALL put_field("PRSWANCIEN", "PRSWANCIEN", prsw_ancien)
-
-  CALL put_field("UANCIEN", "UANCIEN", u_ancien)
-
-  CALL put_field("VANCIEN", "VANCIEN", v_ancien)
-
-  CALL put_field("CLWCON", "Eau liquide convective", clwcon)
-
-  CALL put_field("RNEBCON", "Nebulosite convective", rnebcon)
-
-  CALL put_field("RATQS", "Ratqs", ratqs)
-
-  ! run_off_lic_0
-
-  CALL put_field("RUNOFFLIC0", "Runofflic0", run_off_lic_0)
-
-  ! DEB TKE PBL !
-
-  IF (iflag_pbl>1) then
-    CALL put_field_srf3("TKE", "Energ. Cineti. Turb.", &
-         pbl_tke(:,:,:))
-    CALL put_field_srf3("DELTATKE", "Del TKE wk/env.", &
-         wake_delta_pbl_tke(:,:,:))
-  END IF
-
-  ! FIN TKE PBL !
-  !IM ajout zmax0, f0, sig1, w01
-  !IM wake_deltat, wake_deltaq, wake_s, wake_cstar, wake_pe, wake_fip
-
-  CALL put_field("ZMAX0", "ZMAX0", zmax0)
-
-  CALL put_field("F0", "F0", f0)
-
-  CALL put_field("sig1", "sig1 Emanuel", sig1)
-
-  CALL put_field("w01", "w01 Emanuel", w01)
-
-  ! wake_deltat
-  CALL put_field("WAKE_DELTAT", "WAKE_DELTAT", wake_deltat)
-
-  CALL put_field("WAKE_DELTAQ", "WAKE_DELTAQ", wake_deltaq)
-
-  CALL put_field("WAKE_S", "Wake frac. area", wake_s)
-
-  CALL put_field("WAKE_DENS", "Wake num. /unit area", wake_dens)
-
-  CALL put_field("WAKE_CSTAR", "WAKE_CSTAR", wake_cstar)
-
-  CALL put_field("WAKE_PE", "WAKE_PE", wake_pe)
-
-  CALL put_field("WAKE_FIP", "WAKE_FIP", wake_fip)
-
-  ! thermiques
-
-  CALL put_field("FM_THERM", "FM_THERM", fm_therm)
-
-  CALL put_field("ENTR_THERM", "ENTR_THERM", entr_therm)
-
-  CALL put_field("DETR_THERM", "DETR_THERM", detr_therm)
-
-  CALL put_field("ALE_BL", "ALE_BL", ale_bl)
-
-  CALL put_field("ALE_BL_TRIG", "ALE_BL_TRIG", ale_bl_trig)
-
-  CALL put_field("ALP_BL", "ALP_BL", alp_bl)
-
-  CALL put_field("ALE_WAKE", "ALE_WAKE", ale_wake)
-
-  CALL put_field("ALE_BL_STAT", "ALE_BL_STAT", ale_bl_stat)
-
-
-  ! trs from traclmdz_mod
-  IF (type_trac == 'lmdz') THEN
-     CALL traclmdz_to_restart(trs)
-     DO it=1, nbtr
+    CALL put_field(pass,"treedrg_ter","freinage arbres",treedrg(:,:,is_ter))
+
+
+    CALL put_field_srf1(pass,"QS"  , "Humidite",qsurf(:,:))
+
+    CALL put_field     (pass,"QSOL", "Eau dans le sol (mm)", qsol)
+
+    CALL put_field_srf1(pass,"EVAP", "Evaporation", fevap(:,:))
+
+    CALL put_field_srf1(pass,"SNOW", "Neige", snow(:,:))
+
+    CALL put_field(pass,"RADS", "Rayonnement net a la surface", radsol)
+
+    CALL put_field(pass,"solsw", "Rayonnement solaire a la surface", solsw)
+
+    CALL put_field(pass,"sollw", "Rayonnement IF a la surface", sollw)
+
+    CALL put_field(pass,"sollwdown", "Rayonnement down IF a la surface", sollwdown)
+
+    CALL put_field(pass,"fder", "Derive de flux", fder)
+
+    CALL put_field(pass,"rain_f", "precipitation liquide", rain_fall)
+
+    CALL put_field(pass,"snow_f", "precipitation solide", snow_fall)
+
+    CALL put_field_srf1(pass,"Z0m", "rugosite", z0m(:,:))
+
+    CALL put_field_srf1(pass,"Z0h", "rugosite", z0h(:,:))
+
+    CALL put_field_srf1(pass,"AGESNO", "Age de la neige", agesno(:,:))
+
+    CALL put_field(pass,"ZMEA", "ZMEA", zmea)
+
+    CALL put_field(pass,"ZSTD", "ZSTD", zstd)
+
+    CALL put_field(pass,"ZSIG", "ZSIG", zsig)
+
+    CALL put_field(pass,"ZGAM", "ZGAM", zgam)
+
+    CALL put_field(pass,"ZTHE", "ZTHE", zthe)
+
+    CALL put_field(pass,"ZPIC", "ZPIC", zpic)
+
+    CALL put_field(pass,"ZVAL", "ZVAL", zval)
+
+    CALL put_field(pass,"RUGSREL", "RUGSREL", rugoro)
+
+    CALL put_field(pass,"TANCIEN", "TANCIEN", t_ancien)
+
+    CALL put_field(pass,"QANCIEN", "QANCIEN", q_ancien)
+
+    CALL put_field(pass,"QLANCIEN", "QLANCIEN", ql_ancien)
+
+    CALL put_field(pass,"QSANCIEN", "QSANCIEN", qs_ancien)
+
+    CALL put_field(pass,"PRWANCIEN", "PRWANCIEN", prw_ancien)
+
+    CALL put_field(pass,"PRLWANCIEN", "PRLWANCIEN", prlw_ancien)
+
+    CALL put_field(pass,"PRSWANCIEN", "PRSWANCIEN", prsw_ancien)
+
+    CALL put_field(pass,"UANCIEN", "UANCIEN", u_ancien)
+
+    CALL put_field(pass,"VANCIEN", "VANCIEN", v_ancien)
+
+    CALL put_field(pass,"CLWCON", "Eau liquide convective", clwcon)
+
+    CALL put_field(pass,"RNEBCON", "Nebulosite convective", rnebcon)
+
+    CALL put_field(pass,"RATQS", "Ratqs", ratqs)
+
+    ! run_off_lic_0
+
+    CALL put_field(pass,"RUNOFFLIC0", "Runofflic0", run_off_lic_0)
+
+    ! DEB TKE PBL !
+
+    IF (iflag_pbl>1) then
+      CALL put_field_srf3(pass,"TKE", "Energ. Cineti. Turb.", &
+           pbl_tke(:,:,:))
+      CALL put_field_srf3(pass,"DELTATKE", "Del TKE wk/env.", &
+           wake_delta_pbl_tke(:,:,:))
+    END IF
+
+    ! FIN TKE PBL !
+    !IM ajout zmax0, f0, sig1, w01
+    !IM wake_deltat, wake_deltaq, wake_s, wake_cstar, wake_pe, wake_fip
+
+    CALL put_field(pass,"ZMAX0", "ZMAX0", zmax0)
+
+    CALL put_field(pass,"F0", "F0", f0)
+
+    CALL put_field(pass,"sig1", "sig1 Emanuel", sig1)
+
+    CALL put_field(pass,"w01", "w01 Emanuel", w01)
+
+    ! wake_deltat
+    CALL put_field(pass,"WAKE_DELTAT", "WAKE_DELTAT", wake_deltat)
+
+    CALL put_field(pass,"WAKE_DELTAQ", "WAKE_DELTAQ", wake_deltaq)
+
+    CALL put_field(pass,"WAKE_S", "Wake frac. area", wake_s)
+
+    CALL put_field(pass,"WAKE_DENS", "Wake num. /unit area", wake_dens)
+
+    CALL put_field(pass,"WAKE_CSTAR", "WAKE_CSTAR", wake_cstar)
+
+    CALL put_field(pass,"WAKE_PE", "WAKE_PE", wake_pe)
+
+    CALL put_field(pass,"WAKE_FIP", "WAKE_FIP", wake_fip)
+
+    ! thermiques
+
+    CALL put_field(pass,"FM_THERM", "FM_THERM", fm_therm)
+
+    CALL put_field(pass,"ENTR_THERM", "ENTR_THERM", entr_therm)
+
+    CALL put_field(pass,"DETR_THERM", "DETR_THERM", detr_therm)
+
+    CALL put_field(pass,"ALE_BL", "ALE_BL", ale_bl)
+
+    CALL put_field(pass,"ALE_BL_TRIG", "ALE_BL_TRIG", ale_bl_trig)
+
+    CALL put_field(pass,"ALP_BL", "ALP_BL", alp_bl)
+
+    CALL put_field(pass,"ALE_WAKE", "ALE_WAKE", ale_wake)
+
+    CALL put_field(pass,"ALE_BL_STAT", "ALE_BL_STAT", ale_bl_stat)
+
+
+    ! trs from traclmdz_mod
+    IF (type_trac == 'lmdz') THEN
+       CALL traclmdz_to_restart(trs)
+       DO it=1, nbtr
 !!        iiq=niadv(it+2)                                                           ! jyg
-        iiq=niadv(it+nqo)                                                           ! jyg
-        CALL put_field("trs_"//tname(iiq), "", trs(:, it))
-     END DO
-     IF (carbon_cycle_cpl) THEN
-        IF (.NOT. ALLOCATED(co2_send)) THEN
-           ! This is the case of create_etat0_limit, ce0l
-           ALLOCATE(co2_send(klon))
-           co2_send(:) = co2_ppm0
+          iiq=niadv(it+nqo)                                                           ! jyg
+          CALL put_field(pass,"trs_"//tname(iiq), "", trs(:, it))
+       END DO
+       IF (carbon_cycle_cpl) THEN
+          IF (.NOT. ALLOCATED(co2_send)) THEN
+             ! This is the case of create_etat0_limit, ce0l
+             ALLOCATE(co2_send(klon))
+             co2_send(:) = co2_ppm0
+          END IF
+          CALL put_field(pass,"co2_send", "co2_ppm for coupling", co2_send)
+       END IF
+    END IF
+
+    ! Restart variables for Slab ocean
+    IF (type_ocean == 'slab') THEN
+        IF (nslay.EQ.1) THEN
+          CALL put_field(pass,"tslab", "Slab ocean temperature", tslab)
+        ELSE
+          DO it=1,nslay
+            WRITE(str2,'(i2.2)') it
+            CALL put_field(pass,"tslab"//str2, "Slab ocean temperature", tslab(:,it))
+          END DO
         END IF
-        CALL put_field("co2_send", "co2_ppm for coupling", co2_send)
-     END IF
-  END IF
-
-  ! Restart variables for Slab ocean
-  IF (type_ocean == 'slab') THEN
-      IF (nslay.EQ.1) THEN
-        CALL put_field("tslab", "Slab ocean temperature", tslab)
-      ELSE
-        DO it=1,nslay
-          WRITE(str2,'(i2.2)') it
-          CALL put_field("tslab"//str2, "Slab ocean temperature", tslab(:,it))
-        END DO
-      END IF
-      IF (version_ocean == 'sicINT') THEN
-          CALL put_field("seaice", "Slab seaice (kg/m2)", seaice)
-          CALL put_field("slab_tice", "Slab sea ice temperature", tice)
-      END IF
-  END IF
-
-  if (ok_gwd_rando) call put_field("du_gwd_rando", &
-       "tendency on zonal wind due to flott gravity waves", du_gwd_rando)
-
-  IF (.not. ok_hines .and. ok_gwd_rando) call put_field("du_gwd_front", &
-       "tendency on zonal wind due to acama gravity waves", du_gwd_front)
-
-  if (activate_ocean_skin >= 1) then
-     CALL put_field("ds_ns", "delta salinity near surface", ds_ns)
-     CALL put_field("dT_ns", "delta temperature near surface", dT_ns)
-  end if
+        IF (version_ocean == 'sicINT') THEN
+            CALL put_field(pass,"seaice", "Slab seaice (kg/m2)", seaice)
+            CALL put_field(pass,"slab_tice", "Slab sea ice temperature", tice)
+        END IF
+    END IF
+
+    if (ok_gwd_rando) call put_field(pass,"du_gwd_rando", &
+         "tendency on zonal wind due to flott gravity waves", du_gwd_rando)
+
+    IF (.not. ok_hines .and. ok_gwd_rando) call put_field(pass,"du_gwd_front", &
+         "tendency on zonal wind due to acama gravity waves", du_gwd_front)
+
+    if (activate_ocean_skin >= 1) then
+       CALL put_field(pass, "ds_ns", "delta salinity near surface", ds_ns)
+       CALL put_field(pass, "dT_ns", "delta temperature near surface", dT_ns)
+    end if
+    
+    IF (pass==1) CALL enddef_restartphy
+    IF (pass==2) CALL close_restartphy
+ ENDDO
   
-  CALL close_restartphy
   !$OMP BARRIER
 
@@ -350,7 +356,8 @@
 
 
-SUBROUTINE put_field_srf1(nam,lnam,field)
+SUBROUTINE put_field_srf1(pass,nam,lnam,field)
 
   IMPLICIT NONE
+  INTEGER, INTENT(IN)            :: pass
   CHARACTER(LEN=*),  INTENT(IN) :: nam, lnam
   REAL,              INTENT(IN) :: field(:,:)
@@ -360,5 +367,5 @@
     nm=TRIM(nam)//TRIM(str)
     lm=TRIM(lnam)//" de surface No. "//TRIM(str)
-    CALL put_field(nm,lm,field(:,nsrf))
+    CALL put_field(pass,nm,lm,field(:,nsrf))
   END DO
 
@@ -366,7 +373,8 @@
 
 
-SUBROUTINE put_field_srf2(nam,lnam,field)
+SUBROUTINE put_field_srf2(pass,nam,lnam,field)
 
   IMPLICIT NONE
+  INTEGER, INTENT(IN)            :: pass
   CHARACTER(LEN=*),  INTENT(IN) :: nam, lnam
   REAL,              INTENT(IN) :: field(:,:,:)
@@ -378,5 +386,5 @@
       nm=TRIM(nam)//TRIM(str)
       lm=TRIM(lnam)//" du sol No. "//TRIM(str)
-      CALL put_field(nm,lm,field(:,isoil,nsrf))
+      CALL put_field(pass,nm,lm,field(:,isoil,nsrf))
     END DO
   END DO
@@ -385,7 +393,8 @@
 
 
-SUBROUTINE put_field_srf3(nam,lnam,field)
+SUBROUTINE put_field_srf3(pass,nam,lnam,field)
 
   IMPLICIT NONE
+  INTEGER, INTENT(IN)            :: pass
   CHARACTER(LEN=*),  INTENT(IN) :: nam, lnam
   REAL,              INTENT(IN) :: field(:,:,:)
@@ -395,5 +404,5 @@
     nm=TRIM(nam)//TRIM(str)
     lm=TRIM(lnam)//TRIM(str)
-    CALL put_field(nm,lm,field(:,1:klev+1,nsrf))
+    CALL put_field(pass,nm,lm,field(:,1:klev+1,nsrf))
   END DO
 
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/phys_cal_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/phys_cal_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/phys_cal_mod.F90	(revision 3605)
@@ -1,3 +1,3 @@
-! $Id:$
+! $Id$
 MODULE phys_cal_mod
 ! This module contains information on the calendar at the current time step
@@ -37,5 +37,6 @@
   SUBROUTINE phys_cal_init(annee_ref,day_ref)
 
-    USE IOIPSL, ONLY:  ymds2ju
+    USE IOIPSL, ONLY:  ymds2ju, ioconf_calendar
+    USE mod_phys_lmdz_para, ONLY:  is_master,is_omp_master
     USE ioipsl_getin_p_mod, ONLY: getin_p
 
@@ -47,4 +48,17 @@
     calend = 'earth_360d' ! default
     CALL getin_p("calend",calend)
+
+    IF (is_omp_master) THEN
+      IF (calend == 'earth_360d') THEN
+        CALL ioconf_calendar('360d')
+      ELSE IF (calend == 'earth_365d') THEN
+        CALL ioconf_calendar('noleap')
+      ELSE IF (calend == 'earth_366d' .OR. calend == 'gregorian') THEN
+        CALL ioconf_calendar('gregorian')
+      ELSE
+        CALL abort_physic('phys_cal_init','Mauvais choix de calendrier',1)
+      ENDIF
+    ENDIF
+!$OMP BARRIER
      
     CALL ymds2ju(annee_ref, 1, day_ref, 0., jD_ref)
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/phys_local_var_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/phys_local_var_mod.F90	(revision 3605)
@@ -343,5 +343,5 @@
 !$OMP THREADPRIVATE(zxfluxlat_x, zxfluxlat_w)
 !jyg<
-!!! Entr\E9es suppl\E9mentaires couche-limite
+!!! Entrees supplementaires couche-limite
 !!      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: t_x, t_w
 !!!$OMP THREADPRIVATE(t_x, t_w)
@@ -349,5 +349,10 @@
 !!!$OMP THREADPRIVATE(q_x, q_w)
 !>jyg
-! Variables suppl\E9mentaires dans physiq.F relative au splitting de la surface
+!!! Sorties ferret
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: dtvdf_x, dtvdf_w
+!$OMP THREADPRIVATE(dtvdf_x, dtvdf_w)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: dqvdf_x, dqvdf_w
+!$OMP THREADPRIVATE(dqvdf_x, dqvdf_w)
+! Variables supplementaires dans physiq.F relative au splitting de la surface
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:,:) :: pbl_tke_input
 !$OMP THREADPRIVATE(pbl_tke_input)
@@ -375,4 +380,10 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: t2m_min_mon, t2m_max_mon
 !$OMP THREADPRIVATE(t2m_min_mon, t2m_max_mon)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zq2m_cor, zt2m_cor
+!$OMP THREADPRIVATE(zq2m_cor, zt2m_cor)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zu10m_cor, zv10m_cor
+!$OMP THREADPRIVATE(zu10m_cor, zv10m_cor)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zrh2m_cor, zqsat2m_cor
+!$OMP THREADPRIVATE(zrh2m_cor, zqsat2m_cor)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: weak_inversion
 !$OMP THREADPRIVATE(weak_inversion)
@@ -405,6 +416,6 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)  :: pmflxr, pmflxs
 !$OMP THREADPRIVATE(pmflxr, pmflxs)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)  :: wdtrainA, wdtrainM
-!$OMP THREADPRIVATE(wdtrainA, wdtrainM)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)  :: wdtrainA, wdtrainS, wdtrainM
+!$OMP THREADPRIVATE(wdtrainA, wdtrainS, wdtrainM)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)  :: da, mp
 !$OMP THREADPRIVATE(da, mp)
@@ -417,4 +428,6 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)  :: ev
 !$OMP THREADPRIVATE(ev)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)  :: qtaa
+!$OMP THREADPRIVATE(qtaa)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)  :: clw
 !$OMP THREADPRIVATE(clw)
@@ -578,4 +591,8 @@
       ALLOCATE(plul_st(klon),plul_th(klon))
       ALLOCATE(d_t_vdf(klon,klev),d_q_vdf(klon,klev),d_t_diss(klon,klev))
+
+      ALLOCATE(d_t_vdf_w(klon,klev),d_q_vdf_w(klon,klev))
+      ALLOCATE(d_t_vdf_x(klon,klev),d_q_vdf_x(klon,klev))
+
       ALLOCATE(d_u_vdf(klon,klev),d_v_vdf(klon,klev))
       ALLOCATE(d_t_oli(klon,klev),d_t_oro(klon,klev))
@@ -589,4 +606,5 @@
 ! Special RRTM
       ALLOCATE(ZLWFT0_i(klon,klev+1),ZSWFT0_i(klon,klev+1),ZFLDN0(klon,klev+1))
+      ZFLDN0= 0.
       ALLOCATE(ZFLUP0(klon,klev+1),ZFSDN0(klon,klev+1),ZFSUP0(klon,klev+1))
 !
@@ -603,4 +621,6 @@
       ALLOCATE(dv_gwd_rando(klon,klev),dv_gwd_front(klon,klev))
       ALLOCATE(east_gwstress(klon,klev),west_gwstress(klon,klev))
+      east_gwstress(:,:)=0 !ym missing init
+      west_gwstress(:,:)=0 !ym missing init
       ALLOCATE(d_t_hin(klon,klev))
       ALLOCATE(d_q_ch4(klon,klev))
@@ -627,5 +647,7 @@
       ALLOCATE(od865aer(klon))
       ALLOCATE(dryod550aer(klon))
+      dryod550aer(:) = 0.
       ALLOCATE(abs550aer(klon))
+      abs550aer(:) = 0.
       ALLOCATE(ec550aer(klon,klev))
       ALLOCATE(od550lt1aer(klon))
@@ -672,5 +694,5 @@
       ALLOCATE(toplwad0_aerop(klon), sollwad0_aerop(klon))
 
-! FH Ajout de celles n??cessaires au phys_output_write_mod
+! FH Ajout de celles necessaires au phys_output_write_mod
 
       ALLOCATE(tal1(klon), pal1(klon), pab1(klon), pab2(klon))
@@ -721,6 +743,8 @@
 !!      ALLOCATE(q_x(klon,klev), q_w(klon,klev))
 !>jyg
-      ALLOCATE(d_t_vdf_x(klon,klev), d_t_vdf_w(klon,klev))
-      ALLOCATE(d_q_vdf_x(klon,klev), d_q_vdf_w(klon,klev))
+      ALLOCATE(dtvdf_x(klon,klev), dtvdf_w(klon,klev))
+      dtvdf_x = 0 ; dtvdf_w=0 ;   !ym missing init
+      ALLOCATE(dqvdf_x(klon,klev), dqvdf_w(klon,klev))
+      dqvdf_x = 0 ; dqvdf_w=0 ;   !ym missing init
       ALLOCATE(pbl_tke_input(klon,klev+1,nbsrf))
       ALLOCATE(t_therm(klon,klev), q_therm(klon,klev),u_therm(klon,klev), v_therm(klon,klev))
@@ -736,8 +760,13 @@
       ALLOCATE(zt2m_min_mon(klon), zt2m_max_mon(klon))
       ALLOCATE(t2m_min_mon(klon), t2m_max_mon(klon))
+      ALLOCATE(zq2m_cor(klon), zt2m_cor(klon), zu10m_cor(klon), zv10m_cor(klon))
+      ALLOCATE(zrh2m_cor(klon), zqsat2m_cor(klon))
       ALLOCATE(sens(klon), flwp(klon), fiwp(klon))
       ALLOCATE(alp_bl_conv(klon), alp_bl_det(klon))
+      alp_bl_conv(:)=0 ;  alp_bl_det(:)=0
       ALLOCATE(alp_bl_fluct_m(klon), alp_bl_fluct_tke(klon))
+      alp_bl_fluct_m(:)=0 ; alp_bl_fluct_tke(:)= 0.
       ALLOCATE(alp_bl_stat(klon), n2(klon), s2(klon))
+      alp_bl_stat(:)=0
       ALLOCATE(proba_notrig(klon), random_notrig(klon))
       ALLOCATE(cv_gen(klon))
@@ -764,5 +793,5 @@
 !  Deep convective variables used in phytrac
       ALLOCATE(pmflxr(klon, klev+1), pmflxs(klon, klev+1))
-      ALLOCATE(wdtrainA(klon,klev),wdtrainM(klon,klev))
+      ALLOCATE(wdtrainA(klon,klev),wdtrainS(klon,klev),wdtrainM(klon,klev))
       ALLOCATE(dnwd(klon, klev), upwd(klon, klev) )
       ALLOCATE(ep(klon,klev))                          ! epmax_cape
@@ -774,4 +803,5 @@
       ALLOCATE(ev(klon,klev) )
       ALLOCATE(elij(klon,klev,klev) )
+      ALLOCATE(qtaa(klon,klev) )
       ALLOCATE(clw(klon,klev) )
       ALLOCATE(epmlmMm(klon,klev,klev), eplaMm(klon,klev) )
@@ -968,5 +998,5 @@
       DEALLOCATE(toplwad0_aerop, sollwad0_aerop)
 
-! FH Ajout de celles n??cessaires au phys_output_write_mod
+! FH Ajout de celles necessaires au phys_output_write_mod
       DEALLOCATE(tal1, pal1, pab1, pab2)
       DEALLOCATE(ptstar, pt0, slp)
@@ -1027,4 +1057,6 @@
       DEALLOCATE(zt2m_min_mon, zt2m_max_mon)
       DEALLOCATE(t2m_min_mon, t2m_max_mon)
+      DEALLOCATE(zq2m_cor, zt2m_cor, zu10m_cor, zv10m_cor)
+      DEALLOCATE(zrh2m_cor, zqsat2m_cor)
       DEALLOCATE(sens, flwp, fiwp)
       DEALLOCATE(alp_bl_conv,alp_bl_det)
@@ -1053,5 +1085,5 @@
 
       DEALLOCATE(pmflxr, pmflxs)
-      DEALLOCATE(wdtrainA, wdtrainM)
+      DEALLOCATE(wdtrainA, wdtrainS, wdtrainM)
       DEALLOCATE(upwd, dnwd)
       DEALLOCATE(ep)
@@ -1063,4 +1095,5 @@
       DEALLOCATE(ev )
       DEALLOCATE(elij )
+      DEALLOCATE(qtaa )
       DEALLOCATE(clw )
       DEALLOCATE(epmlmMm, eplaMm )
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 3605)
@@ -7,6 +7,4 @@
   USE indice_sol_mod
   USE aero_mod
-
-
 
   IMPLICIT NONE
@@ -26,14 +24,25 @@
     'io_lat', '', '', (/ ('once', i=1, 10) /))
 
-!!! Comosantes de la coordonnee sigma-hybride
+!!! Composantes de la coordonnee sigma-hybride
 !!! Ap et Bp et interfaces
   TYPE(ctrl_out), SAVE :: o_Ahyb = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
-    'Ahyb', '', '', (/ ('once', i=1, 10) /))
+    'Ahyb', 'Ahyb at level interface', '', (/ ('once', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_Bhyb = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
-    'Bhyb', '', '', (/ ('once', i=1, 10) /))
-  TYPE(ctrl_out), SAVE :: o_Ahyb_inter = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
-    'Ahyb_inter', '', '', (/ ('once', i=1, 10) /))
-  TYPE(ctrl_out), SAVE :: o_Bhyb_inter = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
-    'Bhyb_inter', '', '', (/ ('once', i=1, 10) /))
+    'Bhyb', 'Bhyb at level interface', '', (/ ('once', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_Ahyb_bounds = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
+    'Ahyb_bounds', '', '', (/ ('once', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_Bhyb_bounds = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
+    'Bhyb_bounds', '', '', (/ ('once', i=1, 10) /))
+!!! Composantes de la coordonnee sigma-hybride  au milieu des couches
+!!! Aps et Bps et interfaces
+  TYPE(ctrl_out), SAVE :: o_Ahyb_mid = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
+    'Ahyb_mid', 'Ahyb at the middle of the level', '', (/ ('once', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_Bhyb_mid = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
+    'Bhyb_mid', 'Bhyb at the middle of the level', '', (/ ('once', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_Ahyb_mid_bounds = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
+    'Ahyb_mid_bounds', '', '', (/ ('once', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_Bhyb_mid_bounds = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
+    'Bhyb_mid_bounds', '', '', (/ ('once', i=1, 10) /))
+
   TYPE(ctrl_out), SAVE :: o_Alt = ctrl_out((/ 1, 1, 1, 1, 1, 1, 11, 11, 11, 11/), &
     'Alt', '', '', (/ ('', i=1, 10) /))
@@ -1018,5 +1027,4 @@
 !FC
 
-
   TYPE(ctrl_out), SAVE, DIMENSION(4) :: o_l_mixmin      = (/             &
       ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11, 11/),'l_mixmin_ter',       &
@@ -1284,4 +1292,14 @@
 !--end add ThL
 
+!---CO2 fluxes for interactive CO2 configuration
+  TYPE(ctrl_out), SAVE :: o_flx_co2_ff = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'flx_co2_ff', 'CO2 flux from fossil fuel and cement', '1', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_flx_co2_bb = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'flx_co2_bb', 'CO2 flux from biomass burning', '1', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_flx_co2_ocean = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'flx_co2_ocean', 'CO2 flux from the ocean', '1', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_flx_co2_land = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'flx_co2_land', 'CO2 flux from the land', '1', (/ ('', i=1, 10) /))
+
 #ifdef CPP_StratAer
 !--extinction coefficient
@@ -1292,5 +1310,5 @@
 !--strat aerosol optical depth
   TYPE(ctrl_out), SAVE :: o_tau_strat_550 = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
-    'od550_strat_only', 'Stratospheric Aerosol Optical depth at 550 nm ', '1', (/ ('', i=1, 10) /))
+    'OD550_strat_only', 'Stratospheric Aerosol Optical depth at 550 nm ', '1', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_tau_strat_1020 = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
     'OD1020_strat_only', 'Stratospheric Aerosol Optical depth at 1020 nm ', '1', (/ ('', i=1, 10) /))
@@ -1366,4 +1384,8 @@
   TYPE(ctrl_out), SAVE :: o_temp = ctrl_out((/ 2, 3, 4, 10, 10, 10, 11, 11, 11, 11/), &
     'temp', 'Air temperature', 'K', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_heat_volc = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'heat_volc', 'SW heating rate due to volcano', 'K/s', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_cool_volc = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'cool_volc', 'LW cooling rate due to volcano', 'K/s', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_theta = ctrl_out((/ 2, 3, 4, 10, 10, 10, 11, 11, 11, 11/), &
     'theta', 'Potential air temperature', 'K', (/ ('', i=1, 10) /))
@@ -1508,6 +1530,8 @@
   TYPE(ctrl_out), SAVE :: o_clwcon = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'clwcon', 'Convective Cloud Liquid water content', 'kg/kg', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_Mipsh = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'Mipsh', 'mass flux shed from adiab. ascents', 'kg/m2/s', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_Ma = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'Ma', 'undilute adiab updraft', 'kg/m2/s', (/ ('', i=1, 10) /))
+    'Ma', 'undilute adiab updraft mass flux', 'kg/m2/s', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_dnwd = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'dnwd', 'saturated downdraft', 'kg/m2/s', (/ ('', i=1, 10) /))
@@ -1573,8 +1597,14 @@
   TYPE(ctrl_out), SAVE :: o_wdtrainA = ctrl_out((/ 4, 5, 10,  4, 10, 10, 11, 11, 11, 11 /), &
     'wdtrainA', 'precipitation from AA', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_wdtrainS = ctrl_out((/ 4, 5, 10,  4, 10, 10, 11, 11, 11, 11 /), &
+    'wdtrainS', 'precipitation from shedding of AA', '-', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_wdtrainM = ctrl_out((/ 4, 5, 10,  4, 10, 10, 11, 11, 11, 11 /), &
     'wdtrainM', 'precipitation from mixture', '-', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_Vprecip = ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'Vprecip', 'precipitation vertical profile', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_qtaa = ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'qtaa', 'specific total water in adiabatic ascents', 'kg/kg', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_clwaa = ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'Clwaa', 'specific condensed water in adiabatic ascents', 'kg/kg', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_ftd = ctrl_out((/ 4, 5, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'ftd', 'tend temp due aux descentes precip', '-', (/ ('', i=1, 10) /))
